'use strict';

exports.__esModule = true;
exports.getAst = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * get file ast
 */

var getAst = exports.getAst = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(instance, content, fn) {
    var astCacheInstance, cacheKey, cacheData, debug, ast;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            astCacheInstance = null, cacheKey = '';
            // get ast from cache

            if (!(instance.stc.config.cache !== false)) {
              _context.next = 12;
              break;
            }

            astCacheInstance = getAstCacheInstance(instance.stc, instance.file.extname);
            cacheKey = (0, _stcHelper.md5)(content);
            _context.next = 6;
            return astCacheInstance.get(cacheKey);

          case 6:
            cacheData = _context.sent;

            if (!cacheData) {
              _context.next = 12;
              break;
            }

            debug = instance.stc.debug('cache');

            debug('getAst from cache, file is `' + instance.file.path + '`');
            instance.file.setAst(cacheData);
            return _context.abrupt('return', cacheData);

          case 12:
            _context.next = 14;
            return fn();

          case 14:
            ast = _context.sent;

            if (!astCacheInstance) {
              _context.next = 18;
              break;
            }

            _context.next = 18;
            return astCacheInstance.set(cacheKey, ast);

          case 18:
            return _context.abrupt('return', ast);

          case 19:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getAst(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();
/**
 * get cache instance
 */


exports.getAstCacheInstance = getAstCacheInstance;
exports.checkRunIsExecute = checkRunIsExecute;
exports.checkInMaster = checkInMaster;
exports.getCacheInstance = getCacheInstance;
exports.getConcurrentLimitInstance = getConcurrentLimitInstance;
exports.getAwaitInstance = getAwaitInstance;

var _cluster = require('cluster');

var _stcHelper = require('stc-helper');

var _concurrent_limit = require('./concurrent_limit.js');

var _concurrent_limit2 = _interopRequireDefault(_concurrent_limit);

var _stcAwait = require('stc-await');

var _stcAwait2 = _interopRequireDefault(_stcAwait);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * concurrent limit task instances
 */
var concurrentLimitInstances = {};
/**
 * await instances
 */
var awaitInstances = {};

/**
 * get ast cache instance
 */
function getAstCacheInstance(stc, extname) {
  var astCacheKey = '__ast__';
  var astCacheInstance = stc.cacheInstances[astCacheKey];
  if (!astCacheInstance) {
    astCacheInstance = new stc.cache({
      type: (stc.config.product || 'default') + '/ast/' + extname
    });
    stc.cacheInstances[astCacheKey] = astCacheInstance;
  }
  return astCacheInstance;
}

/**
 * check run method is execute
 */
function checkRunIsExecute(instance, method) {
  if (!instance.prop('__isRun__')) {
    throw new Error(method + ' only allow invoked in update method');
  }
}

/**
 * check in master
 */
function checkInMaster(method) {
  if (!_cluster.isMaster) {
    throw new Error(method + ' method must be invoked in master');
  }
}function getCacheInstance(plugin) {
  var md5Value = plugin.getMd5();
  if (!plugin.stc.cacheInstances[md5Value]) {
    plugin.stc.cacheInstances[md5Value] = new plugin.stc.cache({
      onlyMemory: true
    });
  }
  return plugin.stc.cacheInstances[md5Value];
}

/**
 * get concurrent limit instance
 */
function getConcurrentLimitInstance(limit, ignoreErrorFn, key) {
  if (!(key in concurrentLimitInstances)) {
    concurrentLimitInstances[key] = new _concurrent_limit2.default(limit, ignoreErrorFn);
  }
  return concurrentLimitInstances[key];
}
/**
 * get await instance
 */
function getAwaitInstance(key) {
  if (!(key in awaitInstances)) {
    awaitInstances[key] = new _stcAwait2.default();
  }
  return awaitInstances[key];
}
//# sourceMappingURL=helper.js.map